<?php 
namespace Concrete\Package\CcOptinFree;

use Page;
use Loader;

/*
Page gets all its campaigns ordered by id
If no campaigns, get all subpaged campaigns on parent page ordered by id
If no parent page, return null
*/
class CcOptinActiveCampaigns
{
	private $page;
	private $isParent;

	public function __construct($page, $isParent = false) {
		$this->page = $page;
		$this->isParent = $isParent;
	}

	public function get() {
		return $this->page_getAllCampaigns();
	}

	private function page_getAllCampaigns() {
		$db = Loader::db();
		$cID = $this->page->getCollectionId();

		if($cID != 1) return array();
		$sp = '';

		$SQL = <<<SQL
SELECT campaigns.id FROM cc_optin_campaigns AS campaigns
INNER JOIN cc_optin_campaigns_pages AS pages ON campaigns.id = pages.campaignID AND pages.cID = ?
WHERE campaigns.active
$sp
SQL;


		$SQL .= ' ORDER BY campaigns.id DESC';

		$campaigns = $db->GetCol($SQL, array($cID));
		return $campaigns;
	}

}
