// Generated by CoffeeScript 1.7.1
(function() {
  var ActionForm, t,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  t = window.ccOptin.t;

  window.ccOptin.ActionForm = ActionForm = (function() {
    ActionForm.displayTime = 5000;

    function ActionForm(options) {
      this.actions_resetChoice = __bind(this.actions_resetChoice, this);
      this.form_displayMessage = __bind(this.form_displayMessage, this);
      this.form_submit = __bind(this.form_submit, this);
      this.form_displayFlash = __bind(this.form_displayFlash, this);
      this.form_name = __bind(this.form_name, this);
      this.changed = __bind(this.changed, this);
      this.submit = __bind(this.submit, this);
      this.reload = __bind(this.reload, this);
      this.create = __bind(this.create, this);
      t = window.ccOptin.t;
      this.form = $(options.form);
      this.actions = options.actions ? $(options.actions) : this.form.find('select:first');
      this.confirmMessage = options.confirmMessage || t('Please confirm "%s" action');
      this.cookie = $.cookie;
      this.noSubmit = options.noSubmit || false;
      this.noConfirm = options.noConfirm || false;
      if (!this.form.is('form')) {
        throw "No form found";
      }
      if (!this.actions.is('select' || this.noSubmit)) {
        throw "No action select menu found";
      }
      this.done = options.done;
      this.autoReload = options.autoReload;
      this._reloading = false;
      this.ajaxForm = new ccOptin.AjaxForm({
        form: this.form,
        onBefore: options.before || function() {},
        onValidationError: function() {
          return false;
        },
        noSubmit: true
      });
    }

    ActionForm.prototype.create = function() {
      this.form_displayFlash();
      if (!this.noSubmit) {
        this.actions.on('change', (function(_this) {
          return function() {
            return _this.form_submit(_this.actions.val());
          };
        })(this));
      }
      return this;
    };

    ActionForm.prototype.reload = function(message) {
      this._reloading = true;
      this.cookie(this.form_name(), JSON.stringify(message), {
        expires: 1
      });
      setTimeout(((function(_this) {
        return function() {
          return _this.ajaxForm.loaders.show();
        };
      })(this)), 2);
      window.location.reload(true);
      return this;
    };

    ActionForm.prototype.submit = function(action, actionText, actionField) {
      if (action == null) {
        action = null;
      }
      if (actionText == null) {
        actionText = null;
      }
      if (actionField == null) {
        actionField = 'action';
      }
      return this.form_submit(action, actionText, actionField);
    };

    ActionForm.prototype.changed = function() {
      return this.ajaxForm.changed();
    };

    ActionForm.prototype.form_name = function() {
      return 'actionform_' + this.form.attr('id');
    };

    ActionForm.prototype.form_displayFlash = function() {
      var data;
      data = this.cookie(this.form_name());
      if (!data) {
        return;
      }
      this.form_displayMessage(JSON.parse(data));
      return this.cookie(this.form_name(), null);
    };

    ActionForm.prototype.form_submit = function(action, actionText, actionField) {
      var actionFormField, confirmText, def;
      if (actionText == null) {
        actionText = null;
      }
      if (actionField == null) {
        actionField = null;
      }
      if (actionText) {
        confirmText = actionText;
      } else {
        confirmText = this.confirmMessage.replace('%s', this.actions.children(':selected').text());
      }
      if (!(this.noConfirm || (action && confirm(confirmText)))) {
        this.actions_resetChoice();
        return $.Deferred().reject().promise();
      }
      if (action && actionField) {
        actionFormField = $("<input type='hidden' />").attr('name', actionField).val(action).appendTo(this.form);
      }
      def = this.ajaxForm.submit();
      if (action && actionField) {
        actionFormField.remove();
      }
      def.fail((function(_this) {
        return function(errors) {
          _this.actions_resetChoice();
          if (typeof message === 'string') {
            if (typeof console !== "undefined" && console !== null ? console.log : void 0) {
              console.log(message);
            }
            alert('An unknown error occured. Please reload page and try again.');
            return;
          }
          return _this.form_displayMessage({
            error: {
              summary: errors.summary
            }
          });
        };
      })(this));
      def.done((function(_this) {
        return function(message) {
          _this.actions_resetChoice();
          if (_this.done && _this.done(action, message) === false) {
            return;
          }
          if (_this.autoReload) {
            return _this.reload(message);
          } else if (!_this._reloading) {
            return _this.form_displayMessage(message);
          }
        };
      })(this));
      return def;
    };

    ActionForm.prototype.form_displayMessage = function(message) {
      var icon, status, text;
      status = message.error ? 'danger' : 'success';
      icon = message.error ? 'warning' : 'check';
      text = message.error ? message.error.summary : message.success;
      if (typeof text !== 'boolean') {
        return ConcreteAlert.notify({
          type: status,
          icon: icon,
          message: text
        });
      }
    };

    ActionForm.prototype.actions_resetChoice = function() {
      return this.actions.find("option[value='']").prop("selected", true);
    };

    return ActionForm;

  })();

}).call(this);
